<template>
  <b-container class="current_task">
    <b-row>
      <b-col class="info">
        <b-row class="title">
          <b-col>{{ _('Заявка от') }} {{ date }}</b-col>
          <b-col class="right">
            <b-dropdown v-if="$store.getters.isManager" :variant="statusColor" :text="statusText" right>
              <b-dropdown-item @click="setStatus(0)">{{ _('На рассмотрении') }}</b-dropdown-item>
              <b-dropdown-item @click="setStatus(1)">{{ _('В работе') }}</b-dropdown-item>
              <b-dropdown-item @click="setStatus(2)">{{ _('Завершено') }}</b-dropdown-item>
              <b-dropdown-item @click="setStatus(3)">{{ _('Отказ') }}</b-dropdown-item>
            </b-dropdown>
            <b-button v-else disabled :variant="statusColor">{{ statusText }}</b-button>
          </b-col>
        </b-row>
        <b-row class="room"><b-col>{{ _('Каб.') }} {{ task.data.room }}</b-col></b-row>
        <b-row class="password" v-if="$store.getters.isManager">
          <b-col>{{ _('Пароль от компьютера') }}: {{ password }}</b-col>
        </b-row>
        <b-row class="text"><b-col>{{ task.data.text }}</b-col></b-row>
      </b-col>
    </b-row>
    <b-row>
      <b-col class="timeline">
        <b-row>
          <b-col class="type 0">
            <div class="time"><span>{{ detailedTime(task.dt_start) }}</span></div>
            <div class="text">{{ _('Заявка создана') }}</div>
          </b-col>
        </b-row>
        <b-row v-for="comment in comments" :key="comment.uid">
          <b-col :class="['type', { tech: comment.type === -1 }]">
            <div class="time">
              <span>{{ detailedTime(comment.dt) }}</span>
              <b-button
                variant="outline-danger"
                size="sm"
                @click="deleteComment(comment)"
                v-if="$store.getters.isManager">
                  {{ _('Удалить') }}
              </b-button>
            </div>
            <div class="text">{{ comment.text }}</div>
          </b-col>
        </b-row>
      </b-col>
    </b-row>
    <b-row>
      <b-col>
        <b-form @submit.prevent="submit">
          <b-row>
            <b-col>
              <label>{{ _('Комментарий') }}</label>
              <b-form-textarea
                v-model="comment"
                :rows="3"
                required
              />
            </b-col>
          </b-row>
          <b-row>
            <b-col>
              <b-button type="submit" variant="success">{{ _('Отправить') }}</b-button>
            </b-col>
          </b-row>
        </b-form>
      </b-col>
    </b-row>
  </b-container>
</template>

<script>
import moment from 'moment'

import { COMMENTS_DELETE, COMMENTS_LOAD, COMMENTS_ADD, TASKS_UPDATE } from '../data/actions-types'

export default {
  name: 'CurrentTask',
  mounted () {
    this.$store.dispatch(COMMENTS_LOAD)
  },
  data () {
    return {
      comment: ''
    }
  },
  computed: {
    task () {
      return this.$store.getters.currentTask
    },
    date () {
      return moment(this.task.dt_start).format('ll')
    },
    password () {
      return this.task.data.password || this._('Без пароля')
    },
    comments () {
      return this.$store.getters.comments
    },
    statusColor () {
      switch (this.task.status) {
        case 1:
          return 'outline-warning'
        case 2:
          return 'outline-success'
        case 3:
          return 'outline-danger'
        default:
          return 'outline-secondary'
      }
    },
    statusText () {
      switch (this.task.status) {
        case 1:
          return this._('В работе')
        case 2:
          return this._('Завершено')
        case 3:
          return this._('Отказ')
        default:
          return this._('На рассмотрении')
      }
    }
  },
  methods: {
    detailedTime (time) {
      return moment(time).format('LLLL')
    },
    submit () {
      this.$store.dispatch(COMMENTS_ADD, {
        text: this.comment,
        creator_id: this.$store.getters.userId,
        task_id: this.task.uid
      }).then(() => { this.comment = '' })
    },
    addTechComment (status) {
      this.$store.dispatch(COMMENTS_ADD, {
        text: `${this._('Установлен статус:')} "${this.statusText}"`,
        creator_id: this.$store.getters.userId,
        task_id: this.task.uid,
        type: -1
      })
    },
    setStatus (status) {
      this.$store.dispatch(TASKS_UPDATE, {
        ...this.task,
        dt_end: [2, 3].indexOf(status) !== -1 ? moment().format() : null,
        status: status,
        creator_id: this.task.creator.uid
      }).then(this.addTechComment)
    },
    deleteComment (comment) {
      this.$store.dispatch(COMMENTS_DELETE, comment.uid)
    }
  }
}
</script>

<style lang="scss">
$timeline-color: #eaeaea;

.right {
  text-align: right;
}

.title {
  align-items: center;
  display: flex;
  font-size: 1.2rem;
  justify-content: space-between;
}

.room {
  color: #aaa;
  font-size: .8rem;
}

.password {
  color: #aaa;
  font-size: .8rem;
}

.timeline {
  border-left: 3px solid $timeline-color;
  position: relative;

  .row {
    padding: 14px 0;

    .time {
      align-items: center;
      display: flex;
      height: 32px;
      justify-content: space-between;

      span {
        color: #aaa;
        font-size: .8rem;
      }
    }

    .text {
      word-wrap: break-word;
    }

    .type.tech {
      .text {
        color: #aaa;
        font-style: italic;
      }
    }

    &:before {
      background: $timeline-color;
      border-radius: 2em;
      box-shadow: 0 0 0 3px #fff;
      content: '';
      height: 5px;
      left: -4px;
      margin-top: 14px;
      position: absolute;
      width: 5px;
    }
  }
}
</style>
